package com.senter.demo.temperature.activity;

/**
 * Created by Administrator on 2016/10/14.
 */

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.preference.PreferenceManager;
import android.text.InputFilter;
import android.text.InputType;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.Description;
import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.data.LineDataSet;
import com.github.mikephil.charting.formatter.IValueFormatter;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.interfaces.datasets.ILineDataSet;
import com.github.mikephil.charting.listener.OnChartValueSelectedListener;
import com.github.mikephil.charting.utils.ColorTemplate;
import com.github.mikephil.charting.utils.ViewPortHandler;
import com.senter.demo.temperature.R;
import com.senter.demo.temperature.until.EmissivityEditInputFilter;
import com.senter.demo.temperature.until.ScreenListener;
import com.senter.function.openapi.unstable.InfraredThermometer;

public class TemperatureActivity extends Activity implements View.OnClickListener,
        OnChartValueSelectedListener {

    InfraredThermometer thermometer = InfraredThermometer.getInstance();

    private Button buttonOpen;
    private TextView showtemperature;
    private EditText show_power;
    private LineChart mlinechart;
    private TextView unit;
    // Countdown timer
    private CountDownTimer countDownTimer = new CountDownTimer(3 * 1000, 1 * 1000 - 10) {

        @Override
        public void onTick(long time) {


        }

        @Override
        public void onFinish() {
            AlertDialog.Builder builder = new AlertDialog.Builder(TemperatureActivity.this);


            builder.setMessage(getResources().getString(R.string.open_fail));
            builder.setPositiveButton(getResources().getString(R.string.confirm), new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    countDownTimer.cancel();
                    buttonOpen.setText(getResources().getString(R.string.open));



                    getWindow().clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
                }
            });
            builder.create().show();
            return;
        }
    };


    ScreenListener l = new ScreenListener(this);

    private SharedPreferences sharedPreferences;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);

        initView();
/**
 * Return key stop scanning
 */
        l.begin(new ScreenListener.ScreenStateListener() {

            @Override
            public void onUserPresent() {
                Log.e("onUserPresent", "onUserPresent");
            }

            @Override
            public void onScreenOn() {

            }

            @Override
            public void onScreenOff() {
                if (thermometer.isWorking()) {
                    buttonOpen.setText(getResources().getString(R.string.open));
                    thermometer.stop();
                }
            }
        });
    }
    InfraredThermometer.TemperatureListener temperatureListener=new InfraredThermometer.TemperatureListener() {
        @Override
        public void onNewTemperature(InfraredThermometer.ObjectTemperature temperature) {
            final Float eParameter =temperature.getAsObjectTemperatureByCentigrade();
            final String str=String.format("%.1f",eParameter);

            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    addEntry(eParameter);
                    showtemperature.setText(str + "℃");
                }
            });
        }
    };


    /**
     *
     */
    private void initView() {
        mlinechart = (LineChart) findViewById(R.id.linechart);
        unit = (TextView) findViewById(R.id.unit);
        mlinechart.setOnChartValueSelectedListener(this);
        Description description = new Description();
        description.setText(this.getString(R.string.time)+"  ");
        mlinechart.getDescription().setEnabled(true);
        mlinechart.setDragEnabled(true);
        mlinechart.setScaleEnabled(true);
        mlinechart.setDescription(description);
        mlinechart.setTouchEnabled(true);
        mlinechart.setDrawGridBackground(false);
        // if disabled, scaling can be done on x- and y-axis separately
        mlinechart.setPinchZoom(true);
        LineData data = new LineData();
        data.setValueTextColor(Color.WHITE);
        // add empty data
        mlinechart.setData(data);

        // get the legend (only possible after setting data)
        Legend l = mlinechart.getLegend();

        // modify the legend ...
        l.setForm(Legend.LegendForm.LINE);
        l.setTextColor(Color.WHITE);

        XAxis xl = mlinechart.getXAxis();
        xl.setTextColor(Color.GRAY);
        xl.setDrawGridLines(false);
        xl.setGranularity(0.5f);
        xl.setAvoidFirstLastClipping(true);
        xl.setEnabled(true);

        YAxis leftAxis = mlinechart.getAxisLeft();
        leftAxis.setTextColor(Color.GRAY);
        leftAxis.setAxisMinimum(0f);
        leftAxis.setSpaceTop(20f);
        leftAxis.setDrawGridLines(false);


        YAxis rightAxis = mlinechart.getAxisRight();
        rightAxis.setEnabled(false);

        showtemperature = (TextView) findViewById(R.id.showtemperature);
        show_power = (EditText) findViewById(R.id.show_power);

        String name = sharedPreferences.getString("saveMssage", "");
        if (!(name == null || name.equals(""))) {
            show_power.setText(name);
        }
        buttonOpen = (Button) findViewById(R.id.open);

        XAxis mXAxis = mlinechart.getXAxis();
        mXAxis.setPosition(XAxis.XAxisPosition.BOTTOM);
        buttonOpen.setOnClickListener(this);
        show_power.setFocusable(false);
        InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.toggleSoftInput(0, InputMethodManager.HIDE_NOT_ALWAYS);

        show_power.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                if (actionId == EditorInfo.IME_ACTION_SEND || (event != null && event.getKeyCode() == KeyEvent.KEYCODE_ENTER)) {
                    show_power.setText(show_power.getText().toString());
                    show_power.setFocusable(false);
                    InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.toggleSoftInput(0, InputMethodManager.HIDE_NOT_ALWAYS);
                    return true;
                }
                return false;
            }
        });
    }


    @Override
    public void onClick(View view) {
        switch (view.getId()) {

            case R.id.open:

                if (thermometer.isWorking()) {

                    buttonOpen.setText(this.getString(R.string.open));
                    thermometer.stop();


                    getWindow().clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

                } else {


                    getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

                    buttonOpen.setText(this.getString(R.string.close));

                    Toast.makeText(getApplication(), this.getString(R.string.show_message), Toast.LENGTH_SHORT).show();


                    thermometer.setCurrentObjectEmissivity(Float.valueOf(show_power.getText().toString()));
                    thermometer.start(temperatureListener);
                    countDownTimer.start();
                }

                break;
        }
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menu_settings:
                showAddDialog();
                break;

            default:
                break;
        }
        return super.onOptionsItemSelected(item);
    }


    @Override
    public void onValueSelected(Entry e, Highlight h) {   }

    @Override
    public void onNothingSelected() {   }


    /**
     * Return key stop scanning
     *
     * @param keyCode
     * @param event
     * @return
     */
    public boolean onKeyDown(int keyCode, KeyEvent event) {

        if (keyCode == KeyEvent.KEYCODE_BACK) {
            if (thermometer.isWorking()) {
                thermometer.stop();
            }
            System.exit(0);//
        }
        return super.onKeyDown(keyCode, event);
    }

    /**
     * Add data
     */
    private void addEntry(float message) {

        LineData data = mlinechart.getData();

        if (data != null) {
            countDownTimer.cancel();
            ILineDataSet set = data.getDataSetByIndex(0);

            if (set == null) {
                set = createSet();
                data.addDataSet(set);
            }

            data.addEntry(new Entry(set.getEntryCount(), message), 0);
            data.notifyDataChanged();

            // let the chart know it's data has changed
            mlinechart.notifyDataSetChanged();

            // limit the number of visible entries
            mlinechart.setVisibleXRangeMaximum((int) 10);
            // mChart.setVisibleYRange(30, AxisDependency.LEFT);

            // move to the latest entry
            mlinechart.moveViewToX(data.getEntryCount());

            // this automatically refreshes the chart (calls invalidate())
            // mChart.moveViewTo(data.getXValCount()-7, 55f,
            // AxisDependency.LEFT);
        }
    }

    private LineDataSet createSet() {

        LineDataSet set = new LineDataSet(null, "");
        set.setAxisDependency(YAxis.AxisDependency.LEFT);
        set.setColor(ColorTemplate.getHoloBlue());
        set.setCircleColor(Color.GRAY);
        set.setDrawCircles(true);
        set.setLineWidth(2f);
        set.setCircleRadius(2f);
        set.setFillAlpha(25);


        set.setFillColor(ColorTemplate.getHoloBlue());

        // Sets the format of the data displayed on the broken line. If not set, the default display float data format.

        set.setValueFormatter(new IValueFormatter() {
            @Override
            public String getFormattedValue(float value, Entry entry, int dataSetIndex, ViewPortHandler viewPortHandler) {
                String str = "";
                return str;
            }
        });
        return set;
    }

    /**
     * Pop up dialog

     */

    public void showAddDialog() {

        LayoutInflater factory = LayoutInflater.from(TemperatureActivity.this);
        final View textEntryView = factory.inflate(R.layout.dialogview, null);
        final EditText editTextName = (EditText) textEntryView.findViewById(R.id.editTextName);
        InputFilter[] filters = {new EmissivityEditInputFilter()};
        editTextName.setFilters(filters);
        editTextName.setInputType(InputType.TYPE_CLASS_NUMBER | InputType.TYPE_NUMBER_FLAG_DECIMAL);
        AlertDialog.Builder ad1 = new AlertDialog.Builder(TemperatureActivity.this);
        ad1.setTitle(this.getString(R.string.revise));
        ad1.setView(textEntryView);
        ad1.setPositiveButton(this.getString(R.string.save) , new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int i) {
                String parameter = editTextName.getText().toString();
                Float number=  Float.parseFloat(parameter);
                if(number==0){
                    Toast.makeText(getApplication(), getResources().getString(R.string.zero_message), Toast.LENGTH_SHORT).show();
                    showAddDialog();
                    return;
                }



                show_power.setText(parameter);
                thermometer.setCurrentObjectEmissivity(Float.parseFloat(parameter));

                sharedPreferences.edit().putString("saveMssage", parameter).commit();

                dialog.dismiss();
            }
        });
        ad1.setNegativeButton(this.getString(R.string.no), new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int i) {
                dialog.dismiss();
            }
        });
        ad1.show();

    }
}
