package com.senter.support.openapi.demo.netmanage;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.senter.support.openapi.IHandlerLikeNotify;
import com.senter.support.openapi.StConst;
import com.senter.support.openapi.StNetCfgInfo;
import com.senter.support.openapi.StNetMnger;

import java.util.concurrent.Executors;

public class SdkNetManagerTest extends Activity implements IHandlerLikeNotify {

    private EditText mEtIP = null;
    private EditText mEtNetmask = null;
    private EditText mEtGateway = null;
    private EditText mEtDNS1 = null;
    private EditText mEtDNS2 = null;

    private EditText mEtUser = null;
    private EditText mEtPwd = null;

    private Button mBtnSetNetcard = null;
    private Button mBtnStartPPPoE = null;
    private Button mBtnStopPPPoE = null;
    private Button mBtnGetNetcardInfo = null;
    private Button mBtnCloseNC = null;
    private Button mBtnDHCP = null;

    private TextView mTextViewShowPppoeUserName;
    private TextView mTextViewShowPppoePassWord;
    private TextView mTextViewShowPppoeRx;
    private TextView mTextViewShowPppoeTx;
    private Button mButtonGetPppoeAccount;
    private Button mButtonGetPppoeTraffic;

    private TextView mTextViewShowEth0RxRate;
    private TextView mTextViewShowEth0TxRate;
    private TextView mTextViewShowPppoeRxRate;
    private TextView mTextViewShowPppoeTxRate;
    private Button mButtonGetNetWorkRate;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.act_netmanager_main);

        mEtIP = (EditText) findViewById(R.id.etIP);
        mEtNetmask = (EditText) findViewById(R.id.etNetmask);
        mEtGateway = (EditText) findViewById(R.id.etGateway);
        mEtDNS1 = (EditText) findViewById(R.id.etDNS1);
        mEtDNS2 = (EditText) findViewById(R.id.etDNS2);
        mEtUser = (EditText) findViewById(R.id.etUser);
        mEtPwd = (EditText) findViewById(R.id.etPwd);

        mBtnSetNetcard = (Button) findViewById(R.id.btnSetNetcard);
        mBtnSetNetcard.setOnClickListener(btnClick);

        mBtnStartPPPoE = (Button) findViewById(R.id.btnPPPoEStart);
        mBtnStartPPPoE.setOnClickListener(btnClick);

        mBtnStopPPPoE = (Button) findViewById(R.id.btnPPPoEStop);
        mBtnStopPPPoE.setOnClickListener(btnClick);

        mBtnGetNetcardInfo = (Button) findViewById(R.id.btnGetNetcard);
        mBtnGetNetcardInfo.setOnClickListener(btnClick);

        mBtnCloseNC = (Button) findViewById(R.id.btnCloseNC);
        mBtnCloseNC.setOnClickListener(btnClick);
        mBtnDHCP = (Button) findViewById(R.id.btnDHCP);
        mBtnDHCP.setOnClickListener(btnClick);

        mTextViewShowPppoePassWord = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvPassWord);
        mTextViewShowPppoeUserName = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvUserName);
        mTextViewShowPppoeRx = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvRx);
        mTextViewShowPppoeTx = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvTx);
        mButtonGetPppoeAccount = (Button) findViewById(R.id.idNetManagerActivity_PPPoE_btnGetAccount);
        mButtonGetPppoeTraffic = (Button) findViewById(R.id.idNetManagerActivity_PPPoE_btnGetTraffic);
        mButtonGetPppoeAccount.setOnClickListener(btnClick);
        mButtonGetPppoeTraffic.setOnClickListener(btnClick);


        mTextViewShowEth0RxRate = (TextView) findViewById(R.id.idNetManagerActivity_Eth0_tvRxRate);
        mTextViewShowEth0TxRate = (TextView) findViewById(R.id.idNetManagerActivity_Eth0_tvTxRate);
        mTextViewShowPppoeRxRate = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvRxRate);
        mTextViewShowPppoeTxRate = (TextView) findViewById(R.id.idNetManagerActivity_PPPoE_tvTxRate);
        mButtonGetNetWorkRate = (Button) findViewById(R.id.idNetManagerActivity_NetWork_btnGetRate);
        mButtonGetNetWorkRate.setOnClickListener(btnClick);
    }

    private void refreshNetcfg() {
        StNetCfgInfo nci = StNetMnger.getNCardProp();

        mEtIP.setText(nci.getIP());
        mEtNetmask.setText(nci.getNetmask());
        mEtGateway.setText(nci.getGateway());
        mEtDNS1.setText(nci.getDNS1());
        mEtDNS2.setText(nci.getDNS2());
    }

    OnClickListener btnClick = new OnClickListener() {

        @Override
        public void onClick(View v) {
            /**
             * 以后这个项目将会作为库项目的界面存在，原语句改动如下
             *   注：库项目与普通项目的一个区别就是R类中的int值将不再被final修饰，所以不能再放到switch语句中了
             * @author ZuoQinglin
             */
            int viewId = v.getId();
            if (viewId == R.id.btnSetNetcard) {// 设置网卡
                String strIP = mEtIP.getText().toString();
                String strNetmask = mEtNetmask.getText().toString();
                String strGateway = mEtGateway.getText().toString();
                String strDNS1 = mEtDNS1.getText().toString();
                String strDNS2 = mEtDNS2.getText().toString();
                StNetCfgInfo sci = new StNetCfgInfo(strIP, strNetmask, strGateway, strDNS1, strDNS2);

                StNetMnger.setStaticIP(sci, SdkNetManagerTest.this);
            } else if (viewId == R.id.btnDHCP) {
                StNetMnger.startDHCP(SdkNetManagerTest.this);
            } else if (viewId == R.id.btnGetNetcard) {
                StNetCfgInfo nci = StNetMnger.getNCardProp();
                Toast.makeText(SdkNetManagerTest.this, nci.toString(),
                        Toast.LENGTH_SHORT).show();
                refreshNetcfg();
            } else if (viewId == R.id.btnCloseNC) {
                StNetMnger.disableNcard();
            } else if (viewId == R.id.btnPPPoEStart) {// PPPoE拨号
                String strUser = mEtUser.getText().toString();
                String strPwd = mEtPwd.getText().toString();

                // [Neo] TODO
                StNetMnger.startPPPoEDial(strUser, strPwd, SdkNetManagerTest.this);
            } else if (viewId == R.id.btnPPPoEStop) {// 断开PPPoE
                StNetMnger.stopPPPoEDial();
            } else if (viewId == R.id.idNetManagerActivity_PPPoE_btnGetAccount) {
                StNetMnger.PPPoEAccount account = StNetMnger.getPPPoELatestAccount();
                if (account == null) {
                    mTextViewShowPppoeUserName.setText("");
                    mTextViewShowPppoePassWord.setText("");
                } else {
                    mTextViewShowPppoeUserName.setText(account.getUserName());
                    mTextViewShowPppoePassWord.setText(account.getPassWord());
                }
            } else if (viewId == R.id.idNetManagerActivity_PPPoE_btnGetTraffic) {
                StNetMnger.PPPoETraffic traffic = StNetMnger.getPPPoECurrentTraffic();
                if (traffic == null) {
                    mTextViewShowPppoeRx.setText("");
                    mTextViewShowPppoeTx.setText("");
                } else {
                    mTextViewShowPppoeRx.setText("" + traffic.getRxByByte() + " byte");
                    mTextViewShowPppoeTx.setText("" + traffic.getTxByByte() + " byte");
                }
            } else if (viewId == R.id.idNetManagerActivity_NetWork_btnGetRate) {
                checkRate();
            }
        }
    };

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.act_netmanager_main, menu);
        return true;
    }

    @Override
    public void onNotify(final int arg0, final int arg1, int arg2, Object arg3) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                switch (arg0) {
                    case IHandlerLikeNotify.WHAT_PPPOE:

                        switch (arg1) {
                            case StConst.S_OK:
                                Toast.makeText(SdkNetManagerTest.this, "拨号成功", Toast.LENGTH_SHORT).show();
                                break;
                            case StConst.S_FALSE:
                                Toast.makeText(SdkNetManagerTest.this, "拨号失败", Toast.LENGTH_SHORT).show();
                                break;
                            default:
                                Toast.makeText(SdkNetManagerTest.this, "拨号异常", Toast.LENGTH_SHORT).show();
                                break;
                        }
                        break;
                    case IHandlerLikeNotify.WHAT_NET_LAYER:
                        switch (arg1) {
                            case StConst.S_OK:
                                Toast.makeText(SdkNetManagerTest.this, "静态IP设置成功", Toast.LENGTH_SHORT).show();
                                break;
                            case StConst.S_FALSE:
                                Toast.makeText(SdkNetManagerTest.this, "静态IP设置失败", Toast.LENGTH_SHORT).show();
                                break;
                            default:
                                Toast.makeText(SdkNetManagerTest.this, "静态IP异常", Toast.LENGTH_SHORT).show();
                                break;
                        }
                        break;
                    case IHandlerLikeNotify.WHAT_DHCP:
                        switch (arg1) {
                            case StConst.S_OK:
                                Toast.makeText(SdkNetManagerTest.this, "动态IP获取成功", Toast.LENGTH_SHORT).show();
                                break;
                            case StConst.S_FALSE:
                                Toast.makeText(SdkNetManagerTest.this, "动态IP获取失败", Toast.LENGTH_SHORT).show();
                                break;
                            default:
                                Toast.makeText(SdkNetManagerTest.this, "动态IP异常", Toast.LENGTH_SHORT).show();
                                break;
                        }
                    default:
                        break;
                }
            }
        });
    }


    //----网络速率------------------------------------------------------------------------------------------
    private class RateBean {

        public RateBean(long rxRate, long txRate) {
            RxRate = rxRate;
            TxRate = txRate;
        }

        final long RxRate;
        final long TxRate;
    }

    private void checkRate() {

        if (mGetNetWorkRateTask != null) {
            mGetNetWorkRateTask.cancel(true);
        } else {
            mGetNetWorkRateTask = new GetNetWorkRateTask();
            mGetNetWorkRateTask.executeOnExecutor(Executors.newCachedThreadPool());
        }
    }

    private GetNetWorkRateTask mGetNetWorkRateTask = null;

    private static long lastEth0RxRate = 0;
    private static long lastEth0TxRate = 0;
    private static long lastPPPoERxRate = 0;
    private static long lastPPPoETxRate = 0;


    private class GetNetWorkRateTask extends AsyncTask<Void, RateBean, Void> {


        @Override
        protected void onProgressUpdate(RateBean... values) {
            updateUI(values);
        }

        @Override
        protected void onCancelled() {
            mGetNetWorkRateTask = null;
        }

        @Override
        protected Void doInBackground(Void... params) {

            boolean isFirst = true;

            while (!isCancelled()) {
                StNetMnger.NetworkNodeTraffic ethNodeTraffic = StNetMnger.getNetworkNodeCurrentTraffic(StNetMnger.NetworkNode.eth0);
                StNetMnger.NetworkNodeTraffic pppNodeTraffic = StNetMnger.getNetworkNodeCurrentTraffic(StNetMnger.NetworkNode.ppp0);

                RateBean ethRate, pppRate;

                if (ethNodeTraffic != null) {
                    ethRate = new RateBean(ethNodeTraffic.getRxByByte() - lastEth0RxRate, ethNodeTraffic.getTxByByte() - lastEth0TxRate);
                    lastEth0RxRate = ethNodeTraffic.getRxByByte();
                    lastEth0TxRate = ethNodeTraffic.getTxByByte();
                } else {
                    //eth0未打开
                    ethRate = new RateBean(0, 0);
                }

                if (pppNodeTraffic != null) {
                    pppRate = new RateBean(pppNodeTraffic.getRxByByte() - lastPPPoERxRate, pppNodeTraffic.getTxByByte() - lastPPPoETxRate);
                    lastPPPoERxRate = pppNodeTraffic.getRxByByte();
                    lastPPPoETxRate = pppNodeTraffic.getTxByByte();
                } else {
                    //pppoe未打开
                    pppRate = new RateBean(0, 0);
                }
                if (!isFirst) {
                    publishProgress(ethRate, pppRate);
                } else {
                    publishProgress(new RateBean(0, 0), new RateBean(0, 0));
                    isFirst = false;
                }

                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                    break;
                }
            }

            return null;
        }

        private void updateUI(final RateBean... rateBean) {
            if (rateBean != null) {

                if (rateBean.length >= 1 && rateBean[0] != null) {
                    String eth0RxTate = rateBean[0].RxRate + " Bps";
                    String eth0TxTate = rateBean[0].TxRate + " Bps";
                    mTextViewShowEth0RxRate.setText(eth0RxTate);
                    mTextViewShowEth0TxRate.setText(eth0TxTate);
                }

                if (rateBean.length >= 2 && rateBean[1] != null) {
                    String PPPoERxTate = rateBean[1].RxRate + " Bps";
                    String PPPoETxTate = rateBean[1].TxRate + " Bps";
                    mTextViewShowPppoeRxRate.setText(PPPoERxTate);
                    mTextViewShowPppoeTxRate.setText(PPPoETxTate);
                }
            }
        }
    }
}
