package com.senter.support.openapi.demo.pon;

import java.util.Locale;

import com.senter.support.openapi.StPonTest;
import com.senter.support.openapi.StPonTest.OpticalPower;
import com.senter.support.openapi.StPonTest.WaveLength;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class SdkPonTest extends Activity
{
	Views mViews;
	WaveLength[] wavelengths=new WaveLength[]{WaveLength.WL850nm,WaveLength.WL1300nm,WaveLength.WL1310nm,WaveLength.WL1490nm,WaveLength.WL1550nm,WaveLength.WL1625nm};

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		mViews=new Views().init();
		
	}
	protected void onGetPower(WaveLength wl)
	{
		try
		{
			StPonTest.getInstance().start(wl);
			OpticalPower opv=StPonTest.getInstance().getPower();
			
			String v;
			if (opv==null)
			{
				v="null";
			}else {
				v=String.format(Locale.ENGLISH,"Wavelength:%d  Power:%fdbm   %fmw", opv.getWaveLenth().getWaveLenthByNm(),opv.getPowerByDbm(),Math.pow(10, opv.getPowerByDbm()*0.1));
			}
			
			mViews.setPowerValue(v);
		}
		catch (InterruptedException e)
		{
			e.printStackTrace();
			mViews.setPowerValue("InterruptedException");
		}
	}
	boolean shouldStop=false;

	protected void onShutDown()
	{
		StPonTest.getInstance().stop();
	}
	
	class Views
	{
		Button btn850;
		Button btn1300;
		Button btn1310;
		Button btn1490;
		Button btn1550;
		Button btn1625;
		Button btnShutDown;
		
		TextView tvPowerValue;
		
		Button[] btns=new Button[]{btn850,btn1300,btn1310,btn1490,btn1550,btn1625};
	
		public Views()
		{
			setContentView(R.layout.pon_test);
		}
		Views init()
		{
			btn850=(Button) findViewById(R.id.idPonTest_btn850);
			btn1300=(Button) findViewById(R.id.idPonTest_btn1300);
			btn1310=(Button) findViewById(R.id.idPonTest_btn1310);
			btn1490=(Button) findViewById(R.id.idPonTest_btn1490);
			btn1550=(Button) findViewById(R.id.idPonTest_btn1550);
			btn1625=(Button) findViewById(R.id.idPonTest_btn1625);
			btnShutDown=(Button) findViewById(R.id.idPonTest_btnShutDown);
			
			tvPowerValue=(TextView) findViewById(R.id.idPonTest_tvPowerValue);
			
			Button[] btns=new Button[]{btn850,btn1300,btn1310,btn1490,btn1550,btn1625};
			
			for (int i = 0; i < btns.length; i++)
			{
				final int wvIndex=i;
				btns[i].setOnClickListener(new View.OnClickListener() {
					@Override
					public void onClick(View paramView)
					{
						onGetPower(wavelengths[wvIndex]);
					}
				});
			}
			
			btnShutDown.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View paramView)
				{
					onShutDown();
				}
			});
			return Views.this;
		}
		public void setPowerValue(final String v)
		{
			tvPowerValue.post(new Runnable() {
				@Override
				public void run()
				{
					tvPowerValue.setText(v);
				}
			});
		}
		
	}
}
